/*#################################################################                                        
  Project: EDMA - Ultraschall Sensoren
  Author: Bastian Kramer
  Version: 3.0.0
  Date: 01.09.2018
#################################################################*/

//#################################################################
//COMPILE WITH:     gcc -o ULATRA ULTRA.c
//#################################################################

#define VERSION "3.0.0"

#include <sys/shm.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/ipc.h>

#define SHMSZ     10

// Access from ARM Running Linux

#define BCM2708_PERI_BASE        0x20000000		// Pi_2     0x3F000000
#define GPIO_BASE                (BCM2708_PERI_BASE + 0x200000) /* GPIO controller */


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/timeb.h>

#define PAGE_SIZE (4*1024)
#define BLOCK_SIZE (4*1024)

int  mem_fd;
void *gpio_map;
unsigned long int gpio_base = 0;
unsigned char gRaspi = 0;

// I/O access
volatile unsigned *gpio;


// GPIO setup macros. Always use INP_GPIO(x) before using OUT_GPIO(x) or SET_GPIO_ALT(x,y)
#define INP_GPIO(g) *(gpio+((g)/10)) &= ~(7<<(((g)%10)*3))
#define OUT_GPIO(g) *(gpio+((g)/10)) |=  (1<<(((g)%10)*3))
#define SET_GPIO_ALT(g,a) *(gpio+(((g)/10))) |= (((a)<=3?(a)+4:(a)==4?3:2)<<(((g)%10)*3))

#define GPIO_SET *(gpio+7)  // sets   bits which are 1 ignores bits which are 0
#define GPIO_CLR *(gpio+10) // clears bits which are 1 ignores bits which are 0
#define GPIO_IN *(gpio+13)

//By BK--->
#define GPIO_PULLUP *(gpio+37)	//00 = No Pullup   01 = Pull Down  10 = PullUp
#define GPIO_PULLUP_CL *(gpio+38)	//Set Clock and Clear Clock Notwendig, damit Pullup bernommen wird

void setup_io();

/**********************************************************

Steuerbyte 0:	0	Read/Write freigabe Byte
Steuerbyte 1:	99 	Programm beenden
Datenbyte 0: 
Datenbyte 1: 
Datenbyte 2:
Datenbyte 3: 	
Datenbyte 4: 	

**********************************************************/


long long int GetElapsedMicroSeconds()
{
struct timeval timer_usec; 
long long int timestamp_usec; /* timestamp in microsecond */
 
  if (!gettimeofday(&timer_usec, NULL)) {
    timestamp_usec = ((long long int) timer_usec.tv_sec) * 1000000ll + 
                        (long long int) timer_usec.tv_usec;
  }
  else {
    timestamp_usec = -1;
  }
  return timestamp_usec;
}

int main(int Anz, char* Werte[])
{
long long int timDistanz = 0;
long long int timTimout = 0;
int lDistanz = 0;
char lZ = 0;

	gpio_base = 0x20000000 + 0x200000;

	
	
	setup_io();

	INP_GPIO(7); // must use INP_GPIO before we can use OUT_GPIO
	OUT_GPIO(7);
	INP_GPIO(8); // must use INP_GPIO before we can use OUT_GPIO

	GPIO_PULLUP = 0;	//Pullup aus
	GPIO_PULLUP_CL |= (1 << 7);	//bernehmen
	GPIO_PULLUP_CL &= ~(1 << 7);	//bernehmen rcksetzen
	
	GPIO_PULLUP = 0;	//Pullup aus
	GPIO_PULLUP_CL |= (1 << 8);	//bernehmen
	GPIO_PULLUP_CL &= ~(1 << 8);	//bernehmen rcksetzen
	
	
	//IN_3 Pullup einschalten	//00 = No Pullup   01 = Pull Down  10 = PullUp
	/*GPIO_PULLUP = 2;	//Pullup ein
	GPIO_PULLUP_CL |= (1 << 11);	//bernehmen
	GPIO_PULLUP_CL &= ~(1 << 11);	//bernehmen rcksetzen
	*/
	printf("Starte...\n");
	
	while (1)
	{
		lZ = 5; lDistanz = 0;
		while(lZ > 0)
		{
			//Trigger
			//printf("Trigger\n");
			GPIO_SET = 1 << 7;
			usleep(1000);
			GPIO_CLR = 1 << 7;
			
			//printf("Warte\n");
			timTimout = GetElapsedMicroSeconds() + 500;
			while(!((GPIO_IN >> 8) & 1) && GetElapsedMicroSeconds() < timTimout)
			{
				//warten bis Echo auf 1
			}
			
			//printf("Echo\n");
			timDistanz = GetElapsedMicroSeconds();
			timTimout = GetElapsedMicroSeconds() + 500000;
			while(((GPIO_IN >> 8) & 1) && GetElapsedMicroSeconds() < timTimout)
			{
				//warten bis Echo auf 0
			}
			lDistanz += ((GetElapsedMicroSeconds() - timDistanz) / 58);
			
			usleep(20000);
			lZ--;
		}
		if (timTimout > GetElapsedMicroSeconds())
		printf("Dis: %i\n", lDistanz / 5);
	}
 
} //main

// Set up a memory regions to access GPIO
//
void setup_io()
{	
   /* open /dev/mem */
   if ((mem_fd = open("/dev/mem", O_RDWR|O_SYNC) ) < 0) {
      printf("can't open /dev/mem \n");
      exit(-1);
   }

   /* mmap GPIO */
   gpio_map = mmap(
      NULL,             //Any adddress in our space will do
      BLOCK_SIZE,       //Map length
      PROT_READ|PROT_WRITE,// Enable reading & writting to mapped memory
      MAP_SHARED,       //Shared with other processes
      mem_fd,           //File to map
      gpio_base         //Offset to GPIO peripheral
   );

   close(mem_fd); //No need to keep mem_fd open after mmap

   if (gpio_map == MAP_FAILED) {
      printf("mmap error %d\n", (int)gpio_map);//errno also set!
      exit(-1);
   }

   // Always use volatile pointer!
   gpio = (volatile unsigned *)gpio_map;


} // setup_io